var BlogSchema = {
  schemaName: "Blog",
  model: {
    title: {
      type: "String",
      validator: ["isString"],
    },
    content: {
      type: "String",
    },
    owner: {
      type: "String",
      validator: ["isString"],
    },
    category: {
      type: "String",
      validator: ["isString"],
    },
    admin: {
      type: "[]",
      validator: ["isObjectId"],
    },
    editor: {
      type: "[]",
      validator: ["isObjectId"],
    },
    guest: {
      type: "[]",
      validator: ["isObjectId"],
    },
  },
  resource: {
    database: "mongodb",
    collection: "Task",
  },
  allowedMethods: ["GET", "POST"],
  allowedActions: ["Create", "Edit", "Get", "Delete", "View"],
  allowedRoles: ["admin","editor","guest","owner"]
};

export { BlogSchema };

// Create Blog
// Edit Blog
// Update Blog
// Delete Blog
// Get Blog
// Add Admins
// Add editors
// Remove Admins
// Remove Editors