var ProjectSchema = {
  schemaName: "Task",
  model: {
    projectName: {
      type: "String",
      validator: ["isString"],
    },
    tasks: {
      type: "[Model]",
      model: {
        taskId: {
          validator: ["isObjectId"],
        },
      },
    },
    owner: {
      type: "String",
      validator: ["isString"],
    },
    collaborators: {
      type: "[Model]",
      model: {
        taskId: {
          validator: ["isObjectId"],
        },
      },
    },
    category: {
      type: "String",
      validator: ["isString"],
    },
  },
  resource: {
    database: "mongodb",
    collection: "Task",
  },
  allowedMethods: ["GET", "POST"],
  allowedActions: ["Create", "Update", "Get", "Delete"],
};

export { ProjectSchema };
