const UserSchema = {
  schemaName: "User",
  model: {
    name: {
      type: "String",
      value: null,
      validator: ["isNotEmpty"],
    },
    email: {
      type: "String",
      value: null,
      validator: ["isEmail", "isNotEmpty"],
    },
    password: {
      type: "String",
      value: null,
      validator: ["isValidPassword"],
    },
    servers: {
      type: "[Model]",
      model: {
        serverName: {
          type: "String",
          validator: ["isString"],
        },
        serverType: {
          type: "String",
          validator: ["isString"],
        },
      },
    },
    address: {
      type: "Model",
      model: {
        addresLine1: {
          type: "String",
        },
        street: {
          type: "String",
        },
        city: {
          type: "String",
        },
        state: {
          type: "String",
        },
        country: {
          type: "String",
        },
      },
    },
    avatar: {
      type: "String",
      validator: ["isUrl"],
    },
    mobile: {
      type: "[]",
      validator: ["isPhoneNumber"],
    },
    role: {
      type: "String",
    },
  },
  resource: {
    database: "mongodb",
    collection: "User",
  },
  action: {
    login: {
      id: `email`,
      password: [`password`, `md5`],
    },
    register: {
      hash: [`password`, `md5`],
    },
  },
  filterData: {
    ShowMe: "password",
  },
  allowedMethods: ["GET", "POST"],
  allowedActions: ["Login", "Register", "ShowMe"],
};

export { UserSchema };
