console.log("schema.js loaded");
export const schema = {
  fetchSchema: {
    service: "http",
    method: "fetchData",
    argument: ["target", "href"],
    //e.target.href
  },
  //renderReq Methodflow
  renderReq: {
    service: "rendering",
    method: "updateView",
    argument: ["reqObject.responseid", "strdata"],
  },
  //Signup schema
  signup: {
    event: {
      eventType: ["click"],
    },
    request: {
      validator: ["isArray", "isNotEmpty"],
      action: ["&signUpApiRequest", "&fetchSchema"],
    },
    response: {
      validator: ["isArray", "isNotEmpty"],
      action: [
        //"jsontoHTML",
        {
          updateAll: {
            updatePath: ["reqObject.data"],
            updateView: ["reqObject.responseid", "strdata"],
          },
        },
      ],
    },
  },
  //Login schema
  login: {
    event: {
      eventType: ["click"],
    },
    request: {
      validator: ["isArray", "isNotEmpty"],
      action: ["&loginApiRequest"],
    },
    response: {
      validator: ["isArray", "isNotEmpty"],
      action: [
        //"jsontoHTML",
        {
          updateAll: {
            updatePath: ["reqObject.data"],
            updateView: ["reqObject.responseid", "strdata"],
          },
        },
      ],
    },
  },
  //apiRequestFlow
  signUpApiRequest: {
    service: "POST",
    method: "fetchDataSignup",
    validate: "true",
    argument: ["http://localhost:8080/"],
  },
  //apiRequestFlow
  loginApiRequest: {
    service: "POST",
    validate: "true",
    method: "fetchDataLogin",
    argument: ["http://localhost:8080/"],
  },
  //setlocalStorageFlow
  setLocalStorage: {
    service: "localStorage",
    method: "setLocalStorage",
    argument: ["title", "description"],
    //will use Global object to store password
  },
  //getLocalStorageFlow
  getLocalStorage: {
    service: "localStorage",
    method: "getLocalStorage",
    argument: ["itemJson"],
  },
  //clearStorage
  clearLocalStorage: {
    service: "localStorage",
    method: "clearStorage",
    argument: ["itemJson"],
  },
  //clearListFlow
  clearList: {
    event: {
      eventType: ["click"],
    },
    request: {
      validator: ["isArray", "isNotEmpty"],
      action: ["&clearLocalStorage"],
    },
    response: {
      validator: ["isArray", "isNotEmpty"],
      action: [
        {
          updateAll: {
            updateView: ["reqObject.responseid", "strdata"],
          },
        },
      ],
    },
  },
  //createSchema
  create: {
    event: {
      eventType: ["click"],
    },
    request: {
      validator: ["isArray", "isNotEmpty"],
      action: ["&setLocalStorage", "&getLocalStorage"],
    },
    response: {
      validator: ["isArray", "isNotEmpty"],
      action: [
        {
          updateAll: {
            updateView: ["reqObject.responseid", "strdata"],
          },
        },
      ],
    },
  },
  //navigateSchema
  navigate: {
    event: {
      eventType: ["click"],
    },
    request: {
      validator: ["isArray", "isNotEmpty"],
      action: ["&fetchSchema"],
    },
    response: {
      validator: ["isArray", "isNotEmpty"],
      action: [
        // "jsontoHTML",
        {
          updateAll: {
            updatePath: ["reqObject.data"],
            updateView: ["reqObject.responseid", "strdata"],
          },
        },
      ],
    },
  },
};
//
