
  console.log("everything happens here - one world, is loaded.");

  const { Validator } = await import("./helper/validator.mjs");
  const { actionEntity } = await import("./helper/actionEntity.mjs");
  const { schema } = await import("../form/schema/requestSchemas_browser.mjs");
   class Ehh {
    //passing appConfig
    constructor(appConfig) {
      this.appConfig = appConfig;
    }
    //Start Method adds event listener as per the appConfig.
    async start() {
      //taking itential configuring from appConfig
      console.log(
        this.appConfig.dataSet.envType[0],
        "is the environment from app config"
      );
      switch (this.appConfig.dataSet.envType[0]) {
        case "Node.js":
          console.log("EHH: Node.js environment detected");
          try {
            const { Connection } = await import("./helper/connection.mjs");
            const http = await import("http");
            const port = process.env.PORT || 8080;
            const server = http.createServer();
            await Connection.open();
            
            /**
             * @param  {} server:-target
             * @param  {} port :-Event
             * @param  {} this.appConfig.dataSet.envType[0]:-node/browser
             */
            this.addListner(server, port, this.appConfig.dataSet.envType[0]);
          } catch (error) {
            console.log(error.message);
          }
          break;
        case "Browser":
          console.log("EHH: Browser environment detected");
          try {
            //What are you trying to do here. Please add comments.
            if (this.appConfig.dataSet["defaultListner"].length == 1) {
              var target =
                window[
                  this.appConfig.dataSet["defaultListner"][0]["targetObject"]
                ];
              var allowedEvents =
                this.appConfig.dataSet["defaultListner"][0]["allowedEvent"];
              console.log(allowedEvents);
              for (var i = 0; allowedEvents.length > i; i++) {
                console.log(allowedEvents[i]);
                this.addListner(
                  target,
                  allowedEvents[i],
                  this.appConfig.dataSet.envType[0]
                );
              }
            }
          } catch (error) {
            console.log(error);
          }
          break;
        default:
          console.log("EHH: Unknown environment detected");
      }
    }
    
    /**
     * @param  {} target -> Window/Server
     * @param  {} eventName->Event Name
     * @param  {} env->Environment for code 
     */
    addListner(target, eventName, env) {
      const ehh = this;
      console.log("environment in listener=", env);
      switch (env) {
        case "Browser":
          console.log("Adding Event lsitner for event", eventName);
          target.addEventListener(eventName, this.handleEvent.bind(this));
          break;

        case "Node.js":
          let server = target;
          let port = eventName;
          const handleEventNode = this.handleEvent.bind(this);
          server.on("connection", (req, socket, head) => {
            console.log("Hi I am connected and i'm on connected");
          });
          server.on("close", function (req, res) {
            console.log("Hi server is being closed");
          });
          server.on("request", async function (req, res) {
            console.log("Hi server is getting requestes");
            res.setHeader("Access-Control-Allow-Origin", "*");
            res.setHeader(
              "Access-Control-Allow-Headers",
              "Origin, X-Requested-With, Content-Type, Accept"
            );
            req.cookies = "NULL";
            let { method } = req;
            const { bodyParser } = await import("./helper/bodyParser.mjs");
            switch (method) {
              case "POST":
                //  Handle Event
                req.body = await bodyParser(req); // {key : value}
                console.log("Entering  handle event");
                await ehh.handleEvent(req, res);
                break;
              default:
                break;
            }
          });
          server.listen(port, function () {
            console.log(`Server is Listing on port${port}`);
          });
          server.on("listening", function () {
            console.log("HTTP listening:i am on listening " + port);
          });
          server.on("clientError", function () {
            console.log("client eroor occured");
          });
          break;
        default:
          console.log("EHH: Unknown environment detected");
      }
    }
    
    /**
     * @param  {} e   :- event Object :For Browser event object
     * 
     * @param  {} res :- response from server : For Node Server Response
     */
    async handleEvent(e, res) {
      switch (this.appConfig.dataSet.envType[0]) {
        case "Node.js":
        //Should be loaded during start.
          const { entitySchemas } = await import(
            "../form/schema/entitySchemas/index.mjs"
          );
          const { requestSchemas } = await import(
            "../form/schema/requestSchemas-node.mjs"
          );


          let req = e;
          req.body.entitySchema = entitySchemas[req.body["entity"] + "Schema"];
          req.body.requestSchema =
            requestSchemas[req.body.action + "RequestSchema"];

          // validating method
          let isMethodValid = req.body.entitySchema.allowedMethods.includes(
            req.method
          );
          if (!isMethodValid) {
            throw new Error("Invalid method");
          }
          // validating action
          let isActionValid = req.body.entitySchema.allowedActions.includes(
            req.body.action
          );
          console.log(isActionValid);
          if (!isActionValid) {
            throw new Error("Invalid action");
          }
          console.log("Entering Hanlde Request");
          await this.handleRequest(req.body, req, res);
          break;
        case "Browser":
          if (e.type == "click") {
            console.log("Event=", e);
            e.preventDefault();
            const reqObject = JSON.parse(e.target.getAttribute("req"));
            console.log(schema);
            if (reqObject) {
              //Instead of having  Switch here, we can directly call this.handle Request
              switch (reqObject.operation) {
                case "navigate":
                  this.handleRequest(schema.navigate.request, e, reqObject);
                  break;
                case "signup":
                  this.handleRequest(schema.signup.request, e, reqObject);
                  break;
                case "clearList": {
                  this.handleRequest(schema.clearList.request, e, reqObject);
                  break;
                }
                case "login":
                  this.handleRequest(schema.login.request, e, reqObject);

                  break;
                case "create":
                  this.handleRequest(schema.create.request, e, reqObject);
                  break;
                default:
                  console.log("Event not handleed properly");
                  break;
              }
            } else {
              console.log("Haven't targeted any thing");
            }
          }
      }
    }

    /**
     * @param  {} requestBody= request part of the schema
     * @param  {} e=event
     * @param  {} reqObject=html request attribute
     */
    async handleRequest(requestBody, e, reqObject) {
      // console.log("request", requestBody);

      switch (this.appConfig.dataSet.envType[0]) {
        case "Node.js":
          let body = requestBody;
          let req = e;
          let res = reqObject;
          // Create Task
          let requestSchema = body.requestSchema;
          let request = requestSchema.request;
          let actions = request.action;
          let params = {};
          let functionName;
          try {//import resolveFunction to ehh from helper.
            const { resolveFunction } = await import(
              "./helper/resolveFunction.mjs"
            );

            for (let index = 0; index < actions.length; index++) {
              const element = actions[index];
              if (!element) continue;
              functionName = Object.keys(element)[0];
              let parameters = element[functionName];
              params = {};
              let keys = Object.keys(parameters);
              for (let index = 0; index < keys.length; index++) {
                const key = keys[index];
                const paths = parameters[key].split(".");
                let resolvedParams;
                switch (paths[0]) {
                  case "cache":
                    resolvedParams =
                      requestSchema.request.cache[paths[1]][paths[2]] ||
                      requestSchema.request.cache[paths[1]];
                    params[key] = resolvedParams;
                    break;
                  case "req":
                    resolvedParams = req[paths[1]][paths[2]] || req[paths[1]];
                    params[key] = resolvedParams;
                    break;
                  case "res":
                    resolvedParams = res;
                    params[key] = resolvedParams;
                    break;
                  default:
                    break;
                }
              }

              requestSchema.request.cache[functionName] = await resolveFunction(
                functionName,
                params
              );
            }

            res.end(JSON.stringify(request.cache[functionName]));
          } catch (error) {
            res.writeHead(error.code || 400);
            res.end(error.message);
          }

          break;

        case "Browser":
          console.log("request", requestBody);
          const ehh = this;
          for (let i = 0; i < requestBody.action.length; i++) {
            console.log(`request${[i]}`, requestBody.action[i]);
            if (schema[requestBody.action[i].slice(1, 100)]) {
              switch (requestBody.action[i][0]) {
                case "%": //sign for schema flows
                  console.log(
                    "Request name=",
                    schema[requestBody.action[i].slice(1, 100)]
                  );
                  this.handleRequest(
                    schema[requestBody.action[i].slice(1, 100)].request,
                    e,
                    reqObject
                  );
                  break;
                case "&": //sign for methodFlows
                  console.log(
                    "we have entered in & area",
                    schema[requestBody.action[i].slice(1, 100)].method
                  );
                  switch (schema[requestBody.action[i].slice(1, 100)].method) {
                    case "fetchData":
                      console.log("fetch ke under");
                      let response_data = await this.fetchData(
                        schema[requestBody.action[i].slice(1, 100)].argument,
                        e
                      );
                      this.handleResponse(
                        schema.navigate.response,
                        response_data,
                        e,
                        reqObject
                      );
                      break;

                    case "fetchDataSignup":
                      //ftech data post
                      let data = await fetch(
                        schema[requestBody.action[i].slice(1, 100)].argument[0],
                        {
                          // Adding method type
                          method: `${
                            schema[requestBody.action[i].slice(1, 100)].service
                          }`,

                          // Adding body or contents to send
                          body: JSON.stringify({
                            entity: "User",
                            action: "Register",
                            data: {
                              email: `${
                                document.getElementById("form3Example3c").value
                              }`,
                              name: `${
                                document.getElementById("form3Example1c").value
                              }`,
                              password: `${
                                document.getElementById("form3Example4c").value
                              }`,
                            },
                          }),

                          // Adding headers to the request
                          headers: {
                            "Content-type": "text/plain",
                          },
                        }
                      )
                        // Converting to JSON
                        .then((response) => response.json())

                        // Displaying results to console
                        .then((json) => {
                          return json;
                        });
                      if (
                        schema[requestBody.action[i].slice(1, 100)].validate
                      ) {
                        console.log(data);
                        if (
                          data.success ==
                          schema[requestBody.action[i].slice(1, 100)].validate
                        ) {
                        } else {
                          break;
                        }
                      }
                      break;
                    case "fetchDataLogin":
                      let login_data = await fetch(
                        schema[requestBody.action[i].slice(1, 100)].argument[0],
                        {
                          // Adding method type
                          method: `${
                            schema[requestBody.action[i].slice(1, 100)].service
                          }`,

                          // Adding body or contents to send
                          body: JSON.stringify({
                            entity: "User",
                            action: "Login",
                            data: {
                              email: `${
                                document.getElementById("form2Example1").value
                              }`,
                              password: `${
                                document.getElementById("form2Example2").value
                              }`,
                            },
                          }),

                          // Adding headers to the request
                          headers: {
                            "Content-type": "text/plain",
                            // 'Access-Control-Allow-Origin' : 'http://localhost:8080'
                          },
                        }
                      )
                        // Converting to JSON
                        .then((response) => response.json())

                        // Displaying results to console
                        .then((json) => {
                          return json;
                        })
                        .catch(function (error) {
                          ehh.handleResponse(
                            schema.login.response,
                            "Wrong credentials",
                            e,
                            reqObject
                          );
                        });
                      if (
                        schema[requestBody.action[i].slice(1, 100)].validate
                      ) {
                        if (
                          login_data.success ==
                          schema[requestBody.action[i].slice(1, 100)].validate
                        ) {
                          this.handleResponse(
                            schema.login.response,
                            `You are login ${
                              document.getElementById("form2Example1").value
                            }`,
                            e,
                            reqObject
                          );
                        } else {
                          this.handleResponse(
                            schema.login.response,
                            `Wrong credentials`,
                            e,
                            reqObject
                          );
                        }
                      } else {
                        console.log("no validate");
                      }

                      break;
                    case "clearStorage":
                      if (confirm("Do you areally want to clear?")) {
                        console.log("Clearing the storage");
                        localStorage.clear();
                        let clear = "data is empty";
                        this.handleResponse(
                          schema.clearList.response,
                          clear,
                          e,
                          reqObject
                        );
                      }

                      break;
                    case "setLocalStorage":
                      let tit = document.getElementById(
                        `${
                          schema[requestBody.action[i].slice(1, 100)]
                            .argument[0]
                        }`
                      ).value;
                      let desc = document.getElementById(
                        `${
                          schema[requestBody.action[i].slice(1, 100)]
                            .argument[1]
                        }`
                      ).value;
                      let itemJsonArray = [];
                      let itemJsonArrayStr;
                      if (localStorage.getItem("itemsJson") == null) {
                        itemJsonArray.push([tit, desc]);
                        localStorage.setItem(
                          "itemsJson",
                          JSON.stringify(itemJsonArray)
                        );
                      } else {
                        itemJsonArrayStr = localStorage.getItem("itemsJson");
                        itemJsonArray = JSON.parse(itemJsonArrayStr);
                        itemJsonArray.push([tit, desc]);
                        localStorage.setItem(
                          "itemsJson",
                          JSON.stringify(itemJsonArray)
                        );
                      }

                      break;
                    case "getLocalStorage":
                      this.itemJsonArrayStr = localStorage.getItem("itemsJson");
                      this.itemJsonArray = JSON.parse(this.itemJsonArrayStr);
                      // Populate the table with data in str
                      let str = "";
                      this.itemJsonArray.forEach((element, index) => {
                        str += `
          <pre>
                    <tr>
                    <th scope="row">${index + 1}</th>
                    <td>${element[0]}</td>
                    <td>${element[1]}</td>
                    </tr>
                    </pre>`;
                      });
                      this.handleResponse(
                        schema.create.response,
                        str,
                        e,
                        reqObject
                      );

                      break;
                    default:
                      console.log("Request  not handled");

                      break;
                  }
                  break;

                default:
                  console.log("Eroor");
                  break;
              }
            }
          }
      }
    }
    /**
     * @param  {} responseReq: response part of the schema
     * @param  {} strData: data to be sent to response
     * @param  {} e:event
     * @param  {} reqObject:html request attribute
     */
    async handleResponse(responseReq, strData, e, reqObject) {
      for (let i = 0; i < responseReq.action.length; i++) {
        switch (responseReq.action[i]) {
          case "jsontoHTML":
            let obrData = JSON.parse(strData);
            let res = await actionEntity.json2html(obrData);
            strData = res;
            //console.log(strData)
            console.log("Data changed json to html");
            break;
          case "htmltoJson":
            console.log(".......");
            break;
        }
        if (
          typeof responseReq.action[i] == "object" &&
          responseReq.action[i].updateAll
        ) {
          for (const keys in responseReq.action[0].updateAll) {
            console.log(`${keys}:${responseReq.action[0].updateAll[keys]}`);
            let methods = keys;

            switch (methods) {
              case "updatePath":
                window.history.replaceState("text", "Title", reqObject.data);
                console.log("Path updated");
                break;
              case "updateView":
                try {
                  console.log("custom body", reqObject.responseid);
                  document.getElementById(`${reqObject.responseid}`).innerHTML =
                    strData;
                  console.log("updatating elemennt");
                } catch (e) {
                  console.log("failed with ", e);
                }
                break;
              default:
                console.log("method not found");
            }
          }
        }
      }
    }
    /**
     * @param  {} t->target parameter from event
     * @param  {} e-> event object
     */
    fetchData(t, e) {
      const phref = e[`${t[0]}`][`${t[1]}`];
      console.log(phref);
      const words = phref.split("/");
      const path = words[words.length - 2] + `/` + words[words.length - 1];
      console.log(path);

      console.log("fetching data");
      return fetch(phref).then((response) => response.text());
    }
  }
export { Ehh };