//const Connection = require("./connection"); // toBe part of dbHelper
// import * as Connection from "./connection"; // toBe part of dbHelper
const {Connection} = await import("./connection.mjs")
//const { ObjectID } = require("mongodb");
// import {ObjectID} from "mongodb";
const {ObjectID} = await import("mongodb")

class dbHelper {
  constructor() {}
  // Insert a document in collection
  static async insertOne(db, collection, data) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .insertOne(data);
    return response;
  }
  // Find a document from the collection
  static async findOnebyId(db, collection, _id) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .findOne({ _id: new ObjectID(_id) });
    return response;
  }
  // Find a document from collection
  static async findOneBy(db, collection, filter) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .findOne(filter);
    return response;
  }
  // Find the number of document in a collection
  static async count(db, collection) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .count();
    return response;
  }
  // Update one document using its id
  static async updateOne(db, collection, _id, data) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .findOneAndUpdate(
        { _id: new ObjectID(_id) },
        { $set: data },
        { returnDocument: "after" }
      );
    return response.value;
  }

  static async deleteOne(db, collection, _id) {
    const response = await Connection.connect
      .db(db)
      .collection(collection)
      .deleteOne({ _id: new ObjectID(_id) });
    return response;
  }
}

export {dbHelper};
