//const jwt = require("jsonwebtoken");
import * as jsonwebtoken from "jsonwebtoken";
//const dbHelper = require("./mongoDbHelper");
const { dbHelper } = await import("./mongoDbHelper.mjs");
const jwt = jsonwebtoken.default;

class utilitiesFunctions {
  static async checkRolesOverEntity(schema, entity, user) {
    console.log("Validate Permission Entity");
    let userRole = [];
    let currentUser = user;
    console.log(currentUser);
    let allowedRoles = schema.allowedRoles;
    for (const role of allowedRoles) {
      if (!entity[role]) continue;
      let allowedUsers = entity[role];
      if (typeof allowedUsers == "string") {
        if (allowedUsers == currentUser) {
          userRole.push(role);
        }
      } else {
        for (const user of allowedUsers) {
          if (user == currentUser) {
            userRole.push(role);
          }
        }
      }
    }
    let roleDefination = {
      schema: schema.schemaName,
      entityId: entity._id,
      userId: user,
      userRole: userRole,
    };
    console.log(roleDefination);

    return roleDefination;
  }
  static async validateInputs(schema, data) {
    console.log("Validate Input");
    return data;
  }
  static async insertOneResource(schema, data) {
    const res = await dbHelper.insertOne("qrse", schema.schemaName, data);
    return res;
  }
  static async getOneResource(schema, data) {
    const res = await dbHelper.findOneBy("qrse", schema.schemaName, data);
    if (!res) throw new Error("404 , Not Found");
    return res;
  }
  static async getOneResourceById(schema, data) {
    const res = await dbHelper.findOnebyId("qrse", schema.schemaName, data);
    if (!res) throw new Error("404 , Not Found");
    return res;
  }
  static async createJwtToken(id) {
    const payload = { id: id };
    let secretKey = "1234567890";
    const token = await jwt.sign(payload, secretKey);
    return token;
  }
  static async verifyJwtToken(id) {
    let secretKey = "1234567890";
    const token = await jwt.verify(id, secretKey);
    return token;
  }
  static async addCookies(id, res) {
    res.writeHead(201, {
      "Set-Cookie": "id = " + id,
      "Content-Type": `text/plain`,
    });
    return {
      success: "true",
      data: {
        tokenType: "Bearer",
        token: id,
      },
    };
  }
  static async addOwner(data, owner) {
    if (!owner) throw { code: 401, message: " Unauthorized access" };
    data.owner = owner; //user._id || user.id;
    return data;
  }

  static async decodeBearerToken(headers) {
    console.log("decode Bearer Token");
    if (headers.authorization) {
      let tokenData = headers.authorization.split(" ");
      let token = tokenData[1];
      const verifiedData = await utilitiesFunctions.verifyJwtToken(token);
      return { _id: verifiedData.id };
    }
    return { _id: null };
  }

  static async filterData(action, schema, data) {
    let filterItems = schema.filterData[action];
    filterItems = filterItems.split(" ");
    filterItems.forEach((element) => {
      delete data[element];
    });
    return data;
  }
}

export { utilitiesFunctions };
